
//[]{-------------------------------
//G.M.RC.BASiC   WinAVR .
//AVR SRUDIO4  ۼ .
//
//AVR STUDIO4  : 4.13.528
//WinAVR       : WinAVR-20071221
//
//AVR   : ATmega128
//Clock : 18.4320MHz Ƿ
//  : UART1 Ʈ 38400 BPS
//
//2008.04.XX.X
//н ÷  
// ö
//}-------------------------------------


#include  <AVR/io.h>
#include  <util/delay.h>
#include  "main.h"
#include  ".\uart\uart.h"
#include  ".\adc\adc.h" 



//[G.M.RC.BASiC]
//{
    //G.M.RC.BASiC  ϱ Ѱ.
    #include  ".\gmrcbasic\gmrcbasic.h"
    #include  ".\gmrcbasic\gmrcbasic-msg.h"

//}


int main(void)
{
  //[ʱȭ]
  //{
      //Port ʱȭ.
      PORT_Init();
	  
	  //Uart ʱȭ.
      UART_Init(); 

      //ADC ʱȭ.
      ADC_Init();

  //}

  //[G.M.RC.BASiC  ]
  //{
      //[]{----------------------------------------------------------
      //G.M.RC.BASiC  ϴ  .
      //G.M.RC.BASiC  ɾ Լ Ͽ ϰ  ϴ.
      //}----------------------------------------------------------------

      GMRCBASiC_Example();

  //}

  while(1);

  return(0);

}

void PORT_Init(void)
{
  //[]{------------------------------------
  //Port  ʱȭ Ѵ.
  //⺻ Է & High-Z   ´.
  //RXD  : Pull-Up Է.
  //TXD  :  . 
  //}------------------------------------------ 

  DDRD  = 0x08;
  PORTD = 0x08;

  // AVR ʱⰪ ״ д.

  return;

}

void GMRCBASiC_Example(void)
{
  //[]{---------------------------------------------------------------------------------------------------------  
  //ADC0  ()   коȸθ ̿Ͽ    G.M.RC.BASiC  
  //  ġŭ ̵ϵ Ѵ.
  //  ڴ   ̿Ͽ     ȭ ϴ  ߽ 밡ϴ.
  //ϷẸ    
  //
  // 0  Ѵ.
  //Did : 0   .
  //}---------------------------------------------------------------------------------------------------------------

  //[VAR]
  //{
      int  degree      = 0,  // .  
           save_degree = 0;  // .

      int  av5 = 0x3c1,  //5V ϶ ADC (ִ밪).
           av0 = 0x038,  //0V ϶ ADC (ּҰ).
           avx = 0x00;   //ADC   .

  //}    

  //[ ]
  //{ 
      //  G.M.RC.BASiC  ش  °  Ѵ.
      // ڼ  Ȩ G.M.RC.BASiC ǰ  ٶ.     

      //[ӵ ]
      //{
          //ӵ    ۵.
          //̹      ؾ ϹǷ Ӱ  Ѵ.
          GMRCBASIC_Speed(0, 0, 10);

      //}      

  //}

  //[ ȭ]
  //{
      // while()  ADC0   а ش    G.M.RC.BASiC  Ѵ.

      while(1)
      { 
        //ADC0  б.
        avx = ADC_ReadAdc();  

        //.
        degree = ((double)180 * (double)(avx - av0)) / (double)(av5 - av0);

        if(degree != save_degree)
        {
          //  ȭ ״ٸ ó ʴ´.

          //(  ʴ´).
          GMRCBASIC_Degree(0, 0, d_AccelNo, degree);

        }

        //ʹ    ǹ̰  G.M.RC.BASIC  ϸ ֹǷ ణ ð  ѹ óϴ  Ѵ.
        _delay_ms (10);

        //  .
        save_degree = degree;
          
      }

  //}
  
  return;

}

